#define THIS_IS_MAIN
#include <fstream>
#include <iostream>
#include <iomanip>
#include "matrix.h"

using namespace std;

int main()
{
    int N = 100;
    Matrix H(3,3), evecs;  H = 0.0; H(2,2) = 2.0;
    Vector diag(N), leftoff(N-1), rightoff(N-1), evals;
    diag = 2.0;
    rightoff = leftoff = -1.0;
    Vector rawoff(2);  rawoff = 0.0; rawoff(2) = -1.0;
    Vector rawoffr(2);  rawoffr = 0.0; rawoffr(1) = -1.0;
    for(int sweep = 1; sweep <= 100; sweep++)
	{
        for(int l = 2; l < N; l++)
        {
            H(1,2) = H(2,1) = leftoff(l-1);
            H(1,1) = diag(l-1);
            H(3,3) = diag(l+1);
            H(2,3) = H(3,2) = rightoff(l);
            //cout << "H is " << H;
            EigenValues(H,evals,evecs);
            cout << "energy: " << l << " " << setprecision(12) << evals(1) << endl;
            Vector psi = evecs.Column(1);
            Vector psileft = psi.SubVector(1,2);
            Real nor = Norm(psileft);
            if(nor == 0.0)
                psileft(2) = 1.0;
            else
                psileft *= 1.0 / nor;
            if(l < N-1)
            {
                diag(l) = psileft * (H.SubMatrix(1,2,1,2) * psileft);
                leftoff(l) = psileft * rawoff;
            }
        }
        for(int l = N-1; l > 1; l--)
        {
            H(1,2) = H(2,1) = leftoff(l-1);
            H(1,1) = diag(l-1);
            H(3,3) = diag(l+1);
            H(2,3) = H(3,2) = rightoff(l);
            //cout << "H is " << H;
            EigenValues(H,evals,evecs);
            cout << "energy: " << l << " " << setprecision(12) << evals(1) << endl;
            Vector psi = evecs.Column(1);
            Vector psiright = psi.SubVector(2,3);
            Real nor = Norm(psiright);
            if(nor == 0.0)
                psiright(1) = 1.0;
            else
                psiright *= 1.0 / nor;
            if(l > 2)
            {
                diag(l) = psiright * (H.SubMatrix(2,3,2,3) * psiright);
                rightoff(l-1) = psiright * rawoffr;
            }
        }
	}
    return 0;
}
