#include "mps.h"


void checkLength(const ITensor& A)
    {
    int n = 1;
    for(int i = 1; i <= A.d; i++)
	n *= A.n[i];
    if(A.dat.Length() != n)
	{
	cout << "n = " << n << endl;
	for(int i = 1; i <= A.d; i++)
	    cout << i SP A.n[i] SP A.index(i) << endl;
	cout << endl << A;
	error("bad Length");
	}
    }

void getprodcombiners(const ITensor& A, const ITensor& B, Combiner& cA,Index& iA, 
	Combiner& cB, Index& iB)
    {		// cA and cB should already be initialized with their left indices
    for(int i = 1; i <= A.d; i++)
	if(B.findindex(A.index(i)) == 0 && A.index(i) != IndReIm)
	    cA.addleft(iA, A.index(i));
    for(int i = 1; i <= B.d; i++)
	if(A.findindex(B.index(i)) == 0 && B.index(i) != IndReIm)
	    cB.addleft(iB, B.index(i));
    }

ITensor projup(Index s1)
    {
    Index s1p(primeSite,s1);
    ITensor res(s1,s1p);
    res.val(IV(s1,1),IV(s1p,1)) = 1.0;
    return res;
    }
ITensor projdn(Index s1)
    {
    Index s1p(primeSite,s1);
    ITensor res(s1,s1p);
    res.val(IV(s1,2),IV(s1p,2)) = 1.0;
    return res;
    }
ITensor makesz(Index s1)
    {
        Index s1p(primeSite,s1);
        ITensor res(s1,s1p);
        if (s1.m_ == 2){
            res.val(IV(s1,1),IV(s1p,1)) = 0.5;
            res.val(IV(s1,2),IV(s1p,2)) = -0.5;
        } else if (s1.m_ == 3) {
            res.val(IV(s1,1),IV(s1p,1)) = 1.0;
            res.val(IV(s1,3),IV(s1p,3)) = -1.0;
        } else {
            error("Spin size not implemented yet in makesz.");
        }
        return res;
    }
ITensor makesx(Index s1)
    {
        Index s1p(primeSite,s1);
        ITensor res(s1,s1p);
        if (s1.m_ == 2){
            res.val(IV(s1,1),IV(s1p,2)) = 0.5;
            res.val(IV(s1,2),IV(s1p,1)) = 0.5;
        } else if (s1.m_ == 3) {
            res.val(IV(s1,1),IV(s1p,2)) = ISqrt2;
            res.val(IV(s1,2),IV(s1p,1)) = ISqrt2;
            res.val(IV(s1,2),IV(s1p,3)) = ISqrt2;
            res.val(IV(s1,3),IV(s1p,2)) = ISqrt2;
        } else {
            error("Spin size not implemented yet in makesz.");
        }
        return res;
    }
ITensor makesy(Index s1)
    {
        Index s1p(primeSite,s1);
        ITensor res(s1,s1p);
        if (s1.m_ == 2){
            res.val(IV(s1,1),IV(s1p,2)) = -0.5;
            res.val(IV(s1,2),IV(s1p,1)) = 0.5;
        } else if (s1.m_ == 3) {
            res.val(IV(s1,1),IV(s1p,2)) = -ISqrt2;
            res.val(IV(s1,2),IV(s1p,1)) = ISqrt2;
            res.val(IV(s1,2),IV(s1p,3)) = -ISqrt2;
            res.val(IV(s1,3),IV(s1p,2)) = ISqrt2;
        } else {
            error("Spin size not implemented yet in makesz.");
        }
        return res * Complex_i;
    }
ITensor makeunit(Index s1)
    {
    Index s1p(primeSite,s1);
    ITensor res(s1,s1p);
    for(int i = 1; i <= s1.m(); i++)
	res.val(IV(s1,i),IV(s1p,i)) = 1;
    return res;
    }


ITensor makeQ(int mu, int nu, Index s1)
    {
        Index s1p(primeSite,s1);
        ITensor res(s1,s1p);
        if (s1.m_ == 2) {
            return res * Complex_1; //Q is zero for spin 1/2
        }
        else if (s1.m_ == 3) 
        {
            if (mu == 1 && nu == 1){
                res.val(IV(s1,1),IV(s1p,1)) = -1.0/6.0;
                res.val(IV(s1,1),IV(s1p,3)) = 0.5;
                res.val(IV(s1,2),IV(s1p,2)) = 1.0/3.0;
                res.val(IV(s1,3),IV(s1p,1)) = 0.5;
                res.val(IV(s1,3),IV(s1p,3)) = -1.0/6.0;
                return res * Complex_1;
            } else if ((mu == 1 && nu == 2) || (mu == 2 && nu == 1)){
                res.val(IV(s1,1),IV(s1p,3)) = -0.5;
                res.val(IV(s1,3),IV(s1p,1)) = 0.5;
                return res * Complex_i;
            } else if ((mu == 1 && nu == 3) || (mu == 3 && nu == 1)){
                res.val(IV(s1,1),IV(s1p,2)) = 0.5*ISqrt2;
                res.val(IV(s1,2),IV(s1p,1)) = 0.5*ISqrt2;
                res.val(IV(s1,2),IV(s1p,3)) = -0.5*ISqrt2;
                res.val(IV(s1,3),IV(s1p,2)) = -0.5*ISqrt2;
                return res * Complex_1;
            } else if (mu == 2 && nu == 2){
                res.val(IV(s1,1),IV(s1p,1)) = -1.0/6.0;
                res.val(IV(s1,1),IV(s1p,3)) = -0.5;
                res.val(IV(s1,2),IV(s1p,2)) = 1.0/3.0;
                res.val(IV(s1,3),IV(s1p,1)) = -0.5;
                res.val(IV(s1,3),IV(s1p,3)) = -1.0/6.0;
                return res * Complex_1;
            } else if ((mu == 2 && nu == 3) || (mu == 3 && nu == 2)){
                res.val(IV(s1,1),IV(s1p,2)) = -0.5*ISqrt2;
                res.val(IV(s1,2),IV(s1p,1)) = 0.5*ISqrt2;
                res.val(IV(s1,2),IV(s1p,3)) = 0.5*ISqrt2;
                res.val(IV(s1,3),IV(s1p,2)) = -0.5*ISqrt2;
                return res * Complex_i; 
            } else if (mu == 3 && nu == 3){
                res.val(IV(s1,1),IV(s1p,1)) = 1.0/3.0;
                res.val(IV(s1,2),IV(s1p,2)) = -2.0/3.0;
                res.val(IV(s1,3),IV(s1p,3)) = 1.0/3.0;
                return res * Complex_1;
            } else {
                error("Indices for Q must range between 1 and 3.");
            }
        } else {
            error("Spin size not implemented yet in makeQ.");
        }
    }

ITensor makeP(int i, Index s1)
    {
        Index s1p(primeSite,s1);
        if (s1.m_ == 2) {
            error("makeP not defined for S=1/2");
        }
        else if (s1.m_ == 3) 
        {
            if (i == 1){

                ITensor res(s1,s1p);
                res.dat = 1.0/3.0;
                return res;

            } else if (i == 2 || i == 3){

                ITensor rre(s1,s1p), rim(s1,s1p);

                rre.val(IV(s1,1),IV(s1p,1)) = 1.0/3.0;
                rre.val(IV(s1,2),IV(s1p,2)) = 1.0/3.0;
                rre.val(IV(s1,3),IV(s1p,3)) = 1.0/3.0;
                rre.val(IV(s1,1),IV(s1p,2)) = -1.0/6.0;
                rre.val(IV(s1,1),IV(s1p,3)) = -1.0/6.0;
                rre.val(IV(s1,2),IV(s1p,1)) = -1.0/6.0;
                rre.val(IV(s1,2),IV(s1p,3)) = -1.0/6.0;
                rre.val(IV(s1,3),IV(s1p,1)) = -1.0/6.0;
                rre.val(IV(s1,3),IV(s1p,2)) = -1.0/6.0;

                rim.val(IV(s1,1),IV(s1p,2)) = -ISqrt3/2.0;
                rim.val(IV(s1,1),IV(s1p,3)) = ISqrt3/2.0;
                rim.val(IV(s1,2),IV(s1p,1)) = ISqrt3/2.0;
                rim.val(IV(s1,2),IV(s1p,3)) = -ISqrt3/2.0;
                rim.val(IV(s1,3),IV(s1p,1)) = -ISqrt3/2.0;
                rim.val(IV(s1,3),IV(s1p,2)) = ISqrt3/2.0;

                if(i == 2)
                {
                    return rre * Complex_1 + rim * Complex_i;
                }
                else if(i == 3)
                {
                    return rre * Complex_1 + -1*rim * Complex_i;
                }

            } else {
                error("Index for P must range between 1 and 3.");
            }

        } else {
            error("Spin size not implemented yet in makeP.");
        }
    }
ITensor makezero(Index s1)
    {
    Index s1p(primeSite,s1);
    ITensor res(s1,s1p);
    return res;
    }

ITensor makeBra(Index s, int b, Vec2 Theta, Vec2 Phi, Vec2 Omega)
{
    ITensor reres(s),imres(s);
    if(s.m() == 2) //Spin 1/2
    {
        if(b == 1)
        { //Up state
            reres(1) = Theta.halfCos()*Phi.halfCos();
            imres(1) = -1*Theta.halfCos()*Phi.halfSin();
            reres(2) = Theta.halfSin()*Phi.halfCos();
            imres(2) = Theta.halfSin()*Phi.halfSin();
        }
        else if(b == 2)
        { //Down state
            reres(1) = -1*Theta.halfSin()*Phi.halfCos();
            imres(1) = Theta.halfSin()*Phi.halfSin();
            reres(2) = Theta.halfCos()*Phi.halfCos();
            imres(2) = Theta.halfCos()*Phi.halfSin();
        }
        else error("basis index should be either 1 or 2 for spin 1/2.");
        if(Phi.sin() == 0.0)
            return reres;
        else
            return Complex_1 * reres + -1*Complex_i * imres;
    }
    else //Spin >= 1
    {
        error("Not enough parameters (3) to construct ket.");
    }
}

ITensor makeBra(Index s, int b, Vec2 Theta, Vec2 Phi, Vec2 Omega, Vec2 Alpha)
{
    ITensor reres(s),imres(s);
    if(s.m() == 2) //Spin 1/2
    {
        return makeBra(s,b,Theta,Phi,Omega);
    }
    else if(s.m() == 3) //Spin 1
    {
        /*
         * Regular +1, 0, -1 states are b = 1,2,3
         * with all Vec2's == (1,0).
         */
        if(b == 1)
        { //Up state
            reres(1) = ISqrt2*(Alpha.cos()*Phi.cos()*Omega.cos()*Theta.cos() + Alpha.sin()*Phi.cos()*Omega.cos() - Alpha.cos()*Phi.sin()*Omega.sin() - Alpha.sin()*Phi.sin()*Omega.sin()*Theta.cos());
            imres(1) = ISqrt2*(-Alpha.cos()*Phi.sin()*Omega.cos()*Theta.cos() - Alpha.sin()*Phi.sin()*Omega.cos() - Alpha.cos()*Phi.cos()*Omega.sin() - Alpha.sin()*Phi.cos()*Omega.sin()*Theta.cos());
            reres(2) = Alpha.cos()*Omega.cos()*Theta.sin();
            imres(2) = -Alpha.sin()*Omega.sin()*Theta.sin();
            reres(3) = ISqrt2*(-Alpha.cos()*Phi.cos()*Omega.cos()*Theta.cos() + Alpha.sin()*Phi.cos()*Omega.cos() + Alpha.cos()*Phi.sin()*Omega.sin() - Alpha.sin()*Phi.sin()*Omega.sin()*Theta.cos());
            imres(3) = ISqrt2*(-Alpha.cos()*Phi.sin()*Omega.cos()*Theta.cos() + Alpha.sin()*Phi.sin()*Omega.cos() - Alpha.cos()*Phi.cos()*Omega.sin() + Alpha.sin()*Phi.cos()*Omega.sin()*Theta.cos());
        }
        else if(b == 2)
        { //Zero state
            reres(1) = -ISqrt2*Theta.sin()*Phi.cos();
            imres(1) = ISqrt2*Theta.sin()*Phi.sin();
            reres(2) = Theta.cos();
            imres(2) = 0.0;
            reres(3) = ISqrt2*Theta.sin()*Phi.cos();
            imres(3) = ISqrt2*Theta.sin()*Phi.sin();
        }
        else if(b == 3)
        { //Down state
            reres(1) = ISqrt2*(Alpha.cos()*Phi.cos()*Omega.cos() - Alpha.sin()*Phi.cos()*Omega.cos()*Theta.cos() - Alpha.cos()*Phi.sin()*Omega.sin()*Theta.cos() + Alpha.sin()*Phi.sin()*Omega.sin());
            imres(1) = ISqrt2*(-Alpha.cos()*Phi.sin()*Omega.cos() + Alpha.sin()*Phi.sin()*Omega.cos()*Theta.cos() - Alpha.cos()*Phi.cos()*Omega.sin()*Theta.cos() + Alpha.sin()*Phi.cos()*Omega.sin());
            reres(2) = -Alpha.sin()*Omega.cos()*Theta.sin();
            imres(2) = -Alpha.cos()*Omega.sin()*Theta.sin();
            reres(3) = ISqrt2*(Alpha.cos()*Phi.cos()*Omega.cos() + Alpha.sin()*Phi.cos()*Omega.cos()*Theta.cos() - Alpha.cos()*Phi.sin()*Omega.sin()*Theta.cos() - Alpha.sin()*Phi.sin()*Omega.sin());
            imres(3) = ISqrt2*(Alpha.cos()*Phi.sin()*Omega.cos() + Alpha.sin()*Phi.sin()*Omega.cos()*Theta.cos() + Alpha.cos()*Phi.cos()*Omega.sin()*Theta.cos() + Alpha.sin()*Phi.cos()*Omega.sin());
        }
        else error("basis index should be either 1,2 or 3 for spin 1.");
        if(Phi.sin() == 0.0 && Omega.sin() == 0.0) //Spin lies in the X-Z plane
            return reres;
        else
            return Complex_1 * reres + -1*Complex_i * imres;
    }
    else //Spin >= 3/2
    {
        error("Not enough parameters (4) to construct ket.");
    }
}

void randomunit(Real& x, Real& y, Real& z)
    {
    Real sq;
    do  {
	x = (ran1() - 0.5) * 2.0;
	y = (ran1() - 0.5) * 2.0;
	z = (ran1() - 0.5) * 2.0;
	sq = x*x + y*y + z*z;
	} while(sq > 1.0 || sq == 0.0);
    sq = sqrt(sq);
    x /= sq; y /= sq; z /= sq;
    }

ITensor bondH(Index s1, Index s2)
    {
    Index s1p(primeSite,s1);
    Index s2p(primeSite,s2);
    Matrix Sz(sz()), Splus(splus()), Sminus(sminus());
    ITensor Sz1(s1,s1p), Sz2(s2,s2p);
    ITensor Splus1(s1,s1p), Splus2(s2,s2p);
    ITensor Sminus1(s1,s1p), Sminus2(s2,s2p);
    Sz1.dat = Sz2.dat = Sz.TreatAsVector();
    Splus1.dat = Splus2.dat = Splus.TreatAsVector();
    Sminus1.dat = Sminus2.dat = Sminus.TreatAsVector();
    ITensor H = Sz1 * Sz2 + (0.5 * XXZgamma) * Splus1 * Sminus2 + 
		(0.5 * XXZgamma) * Sminus1 * Splus2;
    return H;
    }

ITensor expbondH(Real tau,Index s1, Index s2,Real enbond)
    {
    Index s1p(primeSite,s1);
    Index s2p(primeSite,s2);
    ITensor H = bondH(s1,s2);
    Matrix matH(4,4);
    H.getMatrix22(s1,s2,s1p,s2p,matH);
    matH *= exp(H.logfac);
    matH -= enbond;
    matH *= -tau;
    Matrix matexpH = Exp(matH);
    ITensor res(H);
    res.fromMatrix22(s1,s2,s1p,s2p,matexpH);
    return res;
    }

void IExp(const MatrixRef& M,Matrix& re, Matrix& im)
    {
    int n = M.Nrows();
    Matrix evec(n, n);
    Matrix y(M), rre(M),iim(M);
    Vector eval(n);
    EigenValues(y, eval, evec);
    int i;
    for (i = 1; i <= n; i++)
	{
	rre.Column(i) = evec.Column(i) * cos(eval(i));
	iim.Column(i) = evec.Column(i) * sin(eval(i));
	}
    re = rre * Transpose(evec);
    im = iim * Transpose(evec);
    }

ITensor expbondiH(Real tau,Index s1, Index s2,Real enbond)
    {
    Index s1p(primeSite,s1);
    Index s2p(primeSite,s2);
    ITensor H = bondH(s1,s2);
    Matrix matH(4,4),ere,eim;
    H.getMatrix22(s1,s2,s1p,s2p,matH);
    matH *= exp(H.logfac);
    matH -= enbond;
    matH *= -tau;
    IExp(matH,ere,eim);
    ITensor resre(H),resim(H);
    resre.fromMatrix22(s1,s2,s1p,s2p,ere);
    resim.fromMatrix22(s1,s2,s1p,s2p,eim);
    return resre * Complex_1 + resim * Complex_i;
    }

ITensor Swap(Index s1,Index s2)
    {
    Index s1p(primeSite,s1);
    Index s2p(primeSite,s2);
    ITensor S(s1,s2,s1p,s2p);
    S.val(IV(s1,1),IV(s2,1),IV(s1p,1),IV(s2p,1)) = 1.0;
    S.val(IV(s1,2),IV(s2,2),IV(s1p,2),IV(s2p,2)) = 1.0;
    S.val(IV(s1,1),IV(s2,2),IV(s1p,2),IV(s2p,1)) = 1.0;
    S.val(IV(s1,2),IV(s2,1),IV(s1p,1),IV(s2p,2)) = 1.0;
    return S;
    }

void EnlargeA(ITensor& A1, ITensor& A2, Index li, int newm)	// Enlarge Link li
    {
    //cout << "enlargeA:  A1, A2, li are " << A1 SP A2 SP li << endl;
    int oldm = li.m();
    Index nli(Link,"nli",newm);
    Matrix trans(oldm,newm);
    trans.Randomize(); trans *= 1.0e-3;
    int minm = min(newm,oldm);
    trans.SubMatrix(1,minm,1,minm) = 1.0;
    ITensor T(nli,li);
    T.dat = trans.TreatAsVector();
    ITensor AA1 = A1 * T;
    ITensor AA2 = A2 * T;
    li.setm(newm);
    AA1.mapindex(nli,li);
    AA2.mapindex(nli,li);
    int i1 = A1.findindex(li);
    A1.n[i1] = newm;
    A1.dat.ReDimension(AA1.dat.Length());
    A1.Assign(AA1);
    int i2 = A2.findindex(li);
    A2.n[i2] = newm;
    A2.dat.ReDimension(AA2.dat.Length());
    A2.Assign(AA2);
    }

void psiphi(MPS& psi, MPS& phi,Real& re, Real& im, Real& logfac)  // <psi | phi>
    {
    if(psi.N != phi.N)
	error("bad N in psiphi");
    MPS psiconj(psi);
    for(int i = 1; i <= psi.N; i++)
	psiconj.A[i] = conj(psi.A[i].primelink());
    ITensor L = phi.A[1] * psiconj.A[1];
    for(int i = 2; i < psi.N; i++)
	L = L * phi.A[i] * psiconj.A[i];
    L = L * phi.A[psi.N];
    ITensor pcA = psiconj.A[psi.N];
    logfac = L.logfac + pcA.logfac;
    L.logfac = pcA.logfac = 0.0;
    if(L.findindex(IndReIm) || pcA.findindex(IndReIm))
	{
	ITensor Li,Lr,pi,pr;
	L.SplitReIm(Lr,Li);
	pcA.SplitReIm(pr,pi);
	re = Dot(Lr,pr) - Dot(Li,pi);
	im = Dot(Lr,pi) + Dot(Li,pr);
	}
    else
	im = 0.0, re = Dot(L,pcA);
    }

void psiphi(MPS& psi, MPS& phi,Real& re, Real& im)  // <psi | phi>
{
    Real logfac = 0.0;
    psiphi(psi,phi,re,im,logfac);
    re *= exp(logfac);
    im *= exp(logfac);
    return;
}

void psiphi(MPO& psi, MPO& phi,Real& re, Real& im, Real& logfac)  // Tr{psi^+ phi} = <psi | phi>
    {
    MPS mpsi, mphi;
    MPO_to_MPS(psi,mpsi);
    MPO_to_MPS(phi,mphi);
    psiphi(mpsi,mphi,re,im,logfac);
    }

void psiHphi(MPS& psi, MPO& H, MPS& phi, Real& re, Real& im, Real& logfac) //<psi|H|phi>
    {
    if(psi.N != phi.N || psi.N != H.N)
    {
        error("bad N in psiHphi");
    }
    MPS psiconj(psi);
    for(int i = 1; i <= H.N; i++)
	{
	//cout << "psi is " << i << psi.A[i] << endl;
	psiconj.A[i] = conj(psi.A[i].primelink());
	psiconj.A[i].mapindex(H.si(i),H.ti(i));
	//cout << "psiconj is " << i << psiconj.A[i] << endl;
	}
    ITensor L = phi.A[1] * H.A[1] * psiconj.A[1];
    for(int i = 2; i < H.N; i++)
        L = L * phi.A[i] * H.A[i] * psiconj.A[i];
    L = L * phi.A[H.N] * H.A[H.N];
    ITensor pcA = psiconj.A[psi.N];
    logfac = L.logfac + pcA.logfac;
    L.logfac = pcA.logfac = 0.0;
    if(L.findindex(IndReIm) || pcA.findindex(IndReIm))
	{
	ITensor Li,Lr,pi,pr;
	L.SplitReIm(Lr,Li);
	pcA.SplitReIm(pr,pi);
	re = Dot(Lr,pr) - Dot(Li,pi);
	im = Dot(Lr,pi) + Dot(Li,pr);
	}
    else
	im = 0.0, re = Dot(L,pcA);
    }

void psiHphi(MPS& psi, MPO& H, MPS& phi, Real& re, Real& im) //<psi|H|phi>
{
    Real logfac = 0.0;
    psiHphi(psi,H,phi,re,im,logfac);
    re *= exp(logfac);
    im *= exp(logfac);
    return;
}

void applyMPO(MPS& x, MPO& H, MPS& res)  // apply without SVD or truncation
    {
    if(x.N != H.N)
	error("bad N in applyMPO");
    int N = H.N;
    res = x;
    res.newindices();
    vector<Index> Hxlink(N);
    for(int i = 1; i < N; i++)
	Hxlink[i] = Index(Link,nameint("Hxlink",i));
    Combiner cprev(Hxlink[1],H.LinkInd(1),x.LinkInd(1));
    res.A[1] = x.A[1] * H.A[1] * cprev;
    for(int i = 2; i < N; i++)
	{
	Combiner cnew(Hxlink[i],H.LinkInd(i),x.LinkInd(i));
	res.A[i] = x.A[i] * H.A[i] * cprev * cnew;
	cprev = cnew;
	}
    res.A[N] = x.A[N] * H.A[N] * cprev;
    for(int i = 1; i <= N; i++)
	res.A[i].mapindex(H.ti(i),H.si(i));
    }

static bool doingK = false;

void lancstep(MPS& xi, MPO& H, MPS& xim1,Real alpha , Real beta, MPS& xip1)
    {
    if(xi.N != H.N || xim1.N != H.N)
	error("bad N in lancstep");
    int N = H.N;
    if(doingK)
	{
	xip1 = xi;
	xip1.newindices();
	xip1.maxm = max(3,xip1.maxm/4);
	xip1.cutoff *= min(xip1.cutoff*10.0,1.0e-2);
	xip1.position(N-1);
	xip1.maxm = xi.maxm;
	xip1.cutoff = xi.cutoff;
	}
    else
	{
	MPS xismall(xi);
	xismall.maxm = max(3,xi.maxm/4);
	for(int i = N-1; i >= 1; i--)
	    xismall.position(i);
	applyMPO(xismall,H,xip1);
	xip1.maxm = xi.maxm;
	xip1.position(N-1);
	}
    xip1.position(2);
    xip1.fixends();
    vector<ITensor> RH(N+1), Rxi(N+1), Rxim1(N+1);

    ITensor conxi = conj(xip1.A[N]);
    RH[N] = xi.A[N] * H.A[N];
    RH[N].mapindex(H.ti(N),H.si(N));
    RH[N] = RH[N] * conxi;
    if(alpha != 0.0) Rxi[N] = conxi * xi.A[N];
    if(beta != 0.0) Rxim1[N] = conxi * xim1.A[N];

    conxi = conj(xip1.A[1]);
    RH[1] = xi.A[1] * H.A[1];
    RH[1].mapindex(H.ti(1),H.si(1));
    RH[1] = RH[1] * conxi;
    if(alpha != 0.0) Rxi[1] = conxi * xi.A[1];
    if(beta != 0.0) Rxim1[1] = conxi * xim1.A[1];

    for(int i = N-1; i >= 4; i--)
	{
	ITensor conxi = conj(xip1.A[i]);
	RH[i] = RH[i+1] * xi.A[i] * H.A[i];
	RH[i].mapindex(H.ti(i),H.si(i));
	RH[i] = RH[i] * conxi;
	if(alpha != 0.0) Rxi[i] = Rxi[i+1] * conxi * xi.A[i];
	if(beta != 0.0) Rxim1[i] = Rxim1[i+1] * conxi * xim1.A[i];
	}
    ITensor tt,tta,ttb;
    vector<int> sweepsteps, dir;
    for(int sw = 1; sw <= 5; sw++)
	{
	for(int i = 2; i <= N-2; i++)
	    sweepsteps.push_back(i), dir.push_back(1);
	for(int i = N-2; i > 1; i--)
	    sweepsteps.push_back(i), dir.push_back(-1);
	}
    Real norm3 = -1.0, normN3 = -1.0;
    for(unsigned int jj = 0; jj < dir.size()-1; jj++)
	{
	int i = sweepsteps[jj];
	tt = RH[i-1] * xi.A[i] * H.A[i] * xi.A[i+1] * H.A[i+1] * RH[i+2];
	tt.mapindex(H.ti(i),H.si(i),H.ti(i+1),H.si(i+1));
	if(alpha != 0.0)
	    {
	    tta = Rxi[i-1] * xi.A[i] * xi.A[i+1] * Rxi[i+2];
	    tta.dat *= -alpha;
	    tt += tta;
	    }
	if(beta != 0.0) 
	    { 
	    ttb = Rxim1[i-1] * xim1.A[i] * xim1.A[i+1] * Rxim1[i+2];
	    ttb.dat *= -beta; tt += ttb; 
	    }
	xip1.doSVD(i,tt,dir[jj+1]==1 ? fromleft : fromright,false);
	Real normtt = tt.lognorm();
	if((i == 3 && dir[jj] == 1) || (i == N-3 && dir[jj] == -1))
	    {
	    if(i == 3)   norm3 = normtt; else	normN3 = normtt;
	    Real nordif = fabs(norm3-normN3)/sqrt(norm3*norm3+normN3*normN3);
	    //cout << "nordif: " << i SP nordif SP jj SP norm3 SP normN3 << endl;
	    if(nordif < xip1.cutoff)
		{
		cout << "breaking. " << i SP jj SP nordif SP xip1.cutoff << endl;
		break;
		}
	    }

	if(0 && jj%(dir.size()/4+1)==0)
	    cout << "norm: " << setprecision(12) << i SP tt.lognorm() SP truncerror << endl;
	conxi = conj(xip1.A[i]);
	RH[i] = RH[i-1] * xi.A[i] * H.A[i];
	RH[i].mapindex(H.ti(i),H.si(i));
	RH[i] = RH[i] * conxi;
	if(alpha != 0.0) Rxi[i] = Rxi[i-1] * conxi * xi.A[i];
	if(beta != 0.0) Rxim1[i] = Rxim1[i-1] * conxi * xim1.A[i];
	conxi = conj(xip1.A[i+1]);
	RH[i+1] = RH[i+2] * xi.A[i+1] * H.A[i+1];
	RH[i+1].mapindex(H.ti(i+1),H.si(i+1));
	RH[i+1] = RH[i+1] * conxi;
	if(alpha != 0.0) Rxi[i+1] = Rxi[i+2] * conxi * xi.A[i+1];
	if(beta != 0.0) Rxim1[i+1] = Rxim1[i+2] * conxi * xim1.A[i+1];
	}

    if(0)
	{
	//Now check how good this fit is
	Real xip1Hxire, xip1Hxiim, xip1xire,xip1xiim, xip1xim1re,xip1xim1im;
	Real lf1,lf2,lf3;
	psiHphi(xip1,H,xi,xip1Hxire,xip1Hxiim,lf1);
	psiphi(xip1,xi,xip1xire,xip1xiim,lf2);
	psiphi(xip1,xim1,xip1xim1re,xip1xim1im,lf3);
	cout << " xip1Hxire, xip1Hxiim, xip1xire,xip1xiim, xip1xim1re,xip1xim1re are "
		    << xip1Hxire SP xip1Hxiim SP xip1xire SP xip1xiim SP xip1xim1re SP xip1xim1im 
		    << endl << lf1 SP lf2 SP lf3 << endl;
	}

    }

void applyMPOfit(MPS& x, MPO& K, MPS& res)  // apply using fitting; 
    {
    MPS xim1(x);
    doingK = true;
    lancstep(x, K, xim1,0.0,0.0,res);
    doingK = false;
    }

// res = sum_l=1^n  coefs(l) xi(l)
void fitset(vector<MPS>& xi, Vector& coefs, MPS& res)
    {
    int N = xi[1].N;
    res = xi[1];
    res.newindices();
    res.A[2].dat *= coefs(1);
    res.fixends();
    int n = coefs.Length();
    vector<ITensor> R((N+1)*(n+1));

    ITensor conxi;
    for(int j = 1; j <= n; j++)
	{
	conxi = conj(res.A[N]);
	R[N*n+j] = conxi * xi[j].A[N];
	conxi = conj(res.A[1]);
	R[1*n+j] = conxi * xi[j].A[1];
	}
    for(int i = N-1; i >= 4; i--)
	{
	conxi = conj(res.A[i]);
	for(int j = 1; j <= n; j++)
	    R[i*n+j] = R[(i+1)*n+j] * conxi * xi[j].A[i];
	}
    ITensor tt,tta;
    vector<int> sweepsteps, dir;
    for(int sw = 1; sw <= 5; sw++)
	{
	for(int i = 2; i <= N-2; i++)
	    sweepsteps.push_back(i), dir.push_back(1);
	for(int i = N-2; i > 1; i--)
	    sweepsteps.push_back(i), dir.push_back(-1);
	}
    Real norm3 = -1.0, normN3 = -1.0;
    for(unsigned int jj = 0; jj < dir.size()-1; jj++)
	{
	int i = sweepsteps[jj];
	tt = R[(i-1)*n+1] * xi[1].A[i] * xi[1].A[i+1] * R[(i+2)*n+1];
	tt.dat *= coefs(1);
	for(int j = 2; j <= n; j++)
	    {
	    tta = R[(i-1)*n+j] * xi[j].A[i] * xi[j].A[i+1] * R[(i+2)*n+j];
	    tta.dat *= coefs(j);
	    tt += tta;
	    }
	res.doSVD(i,tt,dir[jj+1] == 1 ? fromleft : fromright,false);
	Real normtt = tt.lognorm();
	if((i == 3 && dir[jj] == 1) || (i == N-3 && dir[jj] == -1))
	    {
	    if(i == 3)   norm3 = normtt; else	normN3 = normtt;
	    Real nordif = fabs(norm3-normN3)/sqrt(norm3*norm3+normN3*normN3);
	    //cout << "nordif: " << i SP nordif SP jj SP norm3 SP normN3 << endl;
	    if(nordif < res.cutoff)
		{
		cout << "breaking. " << i SP jj SP nordif SP res.cutoff << endl;
		break;
		}
	    }
	if(0 && jj%(dir.size()/4+1)==0)
	    cout << "norm: " << setprecision(12) << i SP tt.lognorm() SP truncerror << endl;
	conxi = conj(res.A[i]);
	for(int j = 1; j <= n; j++)
	    R[i*n+j] = R[(i-1)*n+j] * conxi * xi[j].A[i];
	conxi = conj(res.A[i+1]);
	for(int j = 1; j <= n; j++)
	    R[(i+1)*n+j] = R[(i+2)*n+j] * conxi * xi[j].A[i+1];
	}
    }

// apply 1 - epsilon H
void Kstep(MPS& xi, MPO& H, Real epsilon , MPS& res)
    {
    MPS xim1(xi);
    doingK = true;
    lancstep(xi,H, xim1,1.0/epsilon, 0.0, res);
    doingK = false;
    res.A[res.posi].dat *= -epsilon;
    }


void multMPO(MPO& A, MPO& Borig, MPO& res,Real cut, int m)
    {
    if(A.N != Borig.N)
	error("bad N in multMPO");
    int N = Borig.N;
    MPO B(Borig);
    B.newindices();
    for(int i = 1; i <= N; i++)
	{
	B.A[i].mapindex(B.ti(i),B.ti(i).primed());
	B.A[i].mapindex(B.si(i),B.ti(i));
	}
    res = A;
    res.newindices();
    res.maxm = max(3,res.maxm/4);
    res.cutoff = min(res.cutoff*10.0,1.0e-2);
    //res.doroot2 = false;
    for(int i = N-1; i >= 1; i--)
	res.position(i);
    res.maxm = m;
    res.cutoff = cut;
    res.position(2);
    for(int i = 1; i <= N; i++)
	res.A[i].mapindex(res.ti(i),res.ti(i).primed());
    vector<ITensor> R(N+1);

    R[N] = A.A[N] * B.A[N] * conj(res.A[N]);
    R[1] = A.A[1] * B.A[1] * conj(res.A[1]);
    for(int i = N-1; i >= 3; i--)
	R[i] = R[i+1] * A.A[i] * B.A[i] * conj(res.A[i]);

    ITensor tt;
    vector<int> sweepsteps, dir;
    for(int sw = 1; sw <= 20; sw++)
	{
	for(int i = 1; i <= N-1; i++)
	    sweepsteps.push_back(i), dir.push_back(1);
	for(int i = N-1; i >= 1; i--)
	    sweepsteps.push_back(i), dir.push_back(-1);
	}
    Real norm3 = -1.0, normN3 = -1.0;
    int jj;
    for(unsigned jj = 0; jj < dir.size()-1; jj++)
	{
	int i = sweepsteps[jj];
	if(i == 1)
	    tt = A.A[i] * B.A[i] * (R[i+2] * A.A[i+1] * B.A[i+1]);
	else if(i == N-1)
	    tt = R[i-1] * A.A[i] * B.A[i] * (A.A[i+1] * B.A[i+1]);
	else
	    tt = R[i-1] * A.A[i] * B.A[i] * (R[i+2] * A.A[i+1] * B.A[i+1]);
	if(Norm(tt.dat) == 0.0)
	    {
	    cout << "Norm(tt.dat) == 0, i, jj = " << i SP jj << endl;
	    if(i == 1)
		{
		cout << "R[i+2] is " << R[i+2];
		for(int yy = N; yy >= 3; yy--)
		    cout << "norm of R is " << yy SP Norm(R[yy].dat) << endl;
		}
	    else if(i == N-1)
		cout << "R[i-1] is " << R[i-1];
	    else
		cout << "R[i+2] is " << R[i+2] << endl << "R[i-1] is " << R[i-1];
	    exit(0);
	    }
	Vector vtt(tt.dat.Length()); vtt.Randomize(); 
	vtt *= sqrt(fabs(cut));
	if((int)jj < 4*N)
	    tt.dat += vtt;

	res.doSVD(i,tt,dir[jj+1]==1 ? fromleft : fromright,false);
	Real normtt = tt.lognorm();
	if((i == 3 && dir[jj] == 1) || (i == N-3 && dir[jj] == -1))
	    {
	    if(i == 3)   norm3 = normtt; else	normN3 = normtt;
	    Real nordif = fabs(norm3-normN3)/sqrt(norm3*norm3+normN3*normN3);
	    //cout << "nordif: " << i SP nordif SP jj SP norm3 SP normN3 << endl;
	    if(nordif < res.cutoff)
		{
		cout << "breaking. " << i SP jj SP nordif SP res.cutoff << endl;
		break;
		}
	    }
	if(jj%(dir.size()/4+1)==0)
	    cout << "multMPO norm: " << setprecision(12) << i SP normtt << endl;
	if(sweepsteps[jj+1] > i)
	    {
	    if(i == 1)
		R[i] = A.A[i] * B.A[i] * conj(res.A[i]);
	    else
		R[i] = R[i-1] * A.A[i] * B.A[i] * conj(res.A[i]);
	    }
	if(sweepsteps[jj+1] < i)
	    {
	    if(i == N-1)
		R[i+1] = A.A[i+1] * B.A[i+1] * conj(res.A[i+1]);
	    else
		R[i+1] = R[i+2] * A.A[i+1] * B.A[i+1] * conj(res.A[i+1]);
	    }
	}
    cout << "final jj is " << jj SP dir.size() << endl;

    //res.doroot2 = true;
    for(int i = 1; i <= N; i++)
	res.A[i].noprime();
    for(int i = N-1; i >= 1; i--)
	res.position(i);
    }

// res = sum_l=1^n  coefs(l) xi(l)
void fitmposet(vector<MPO>& xi, Vector& coefs, MPO& res,Real cut, int m, bool useres)
    {
    int n = coefs.Length();
    Matrix bigolap(n,n);
    Real totnormsq = 0.0;
    if(1)
	{
	for(int i = 1; i <= n; i++)
	  for(int j = i; j <= n; j++)
	    {
	    Real re,im,lfac;
	    psiphi(xi[i],xi[j],re,im,lfac);
	    bigolap(i,j) = bigolap(j,i) = re * exp(lfac);
	    }
	for(int i = 1; i <= n; i++)
	  for(int j = i; j <= n; j++)
	      totnormsq += coefs(i) * coefs(j) * bigolap(i,j);
	cout << "totnormsq = " << totnormsq << endl;
	}
    Real lognormsq = log(totnormsq);
    int N = xi[1].N;
    res.cutoff = cut; 
    res.maxm = m;
    if(!useres)
	{
	res = xi[1];
	for(int i = 1; i <= N; i++)
	    {
	    Vector vv = res.A[i].dat;
	    vv.Randomize();
	    res.A[i].dat += 0.02 * vv;
	    }
	}
//    res.fixends();
    res.newindices();
    res.position(N-1);
    res.position(2);
    vector<ITensor> R((N+1)*(n+1));
    //MPO::showSVDeigs = true;
    if(coefs.Length() <= 10) cout << "coefs in fitmposet is " << coefs << endl;
    cout << "res.cutoff is " << res.cutoff << endl;

    ITensor conxi;
    for(int j = 1; j <= n; j++)
	{
	R[N*n+j] = conj(res.A[N]) * xi[j].A[N];
	R[1*n+j] = conj(res.A[1]) * xi[j].A[1];
	}
    for(int i = N-1; i >= 3; i--)
	{
	conxi = conj(res.A[i]);
	for(int j = 1; j <= n; j++)
	    R[i*n+j] = R[(i+1)*n+j] * conxi * xi[j].A[i];
	}
    ITensor tt,tta;
    vector<int> sweepsteps, dir;
    for(int sw = 1; sw <= 20; sw++)
	{
	for(int i = 1; i <= N-1; i++)
	    sweepsteps.push_back(i), dir.push_back(1);
	for(int i = N-1; i >= 1; i--)
	    sweepsteps.push_back(i), dir.push_back(-1);
	}
    for(unsigned int jj = 0; jj < dir.size()-1; jj++)
	{
	int i = sweepsteps[jj];
	for(int j = 1; j <= n; j++)
	    {
	    if(i == 1)
		tta = xi[j].A[i] * xi[j].A[i+1] * R[(i+2)*n+j];
	    else if(i == N-1)
		tta = R[(i-1)*n+j] * xi[j].A[i] * xi[j].A[i+1];
	    else
		tta = R[(i-1)*n+j] * xi[j].A[i] * xi[j].A[i+1] * R[(i+2)*n+j];
	    tta.dat *= coefs(j);
	    if(j == 1)
		tt = tta;
	    else
		tt += tta;
	    }
	//cout << "tt is " << tt;
	if((int)jj < 3*N)
	    {
	    Vector v(tt.dat.Length());
	    v.Randomize();
	    tt.dat += Norm(tt.dat) * 0.01 * v;
	    }
	res.doSVD(i,tt,dir[jj+1] == 1 ? fromleft : fromright,false);
	Real rr = tt.lognorm();
	if((int)jj > 3*N && fabs(rr-lognormsq) < res.cutoff * lognormsq)
	    {
	    cout << "breaking. " << i SP jj SP rr SP lognormsq << endl;
	    break;
	    }
	conxi = conj(res.A[i]);
	if(sweepsteps[jj+1] > i)
	    {
	    if(i == 1)
		for(int j = 1; j <= n; j++)
		    R[i*n+j] = conxi * xi[j].A[i];
	    else
		for(int j = 1; j <= n; j++)
		    R[i*n+j] = R[(i-1)*n+j] * conxi * xi[j].A[i];
	    }
	conxi = conj(res.A[i+1]);
	if(sweepsteps[jj+1] < i)
	    {
	    if(i == N-1)
		for(int j = 1; j <= n; j++)
		    R[(i+1)*n+j] = conxi * xi[j].A[i+1];
	    else
		for(int j = 1; j <= n; j++)
		    R[(i+1)*n+j] = R[(i+2)*n+j] * conxi * xi[j].A[i+1];
	    }
	}
    Real re,im,lfac;
    psiphi(res,res,re,im,lfac);
    cout << "Final norms on fitmposet are " << re * exp(lfac) SP totnormsq << endl;
    }

void svdcut(const MatrixRef& A, Matrix& U, Vector& d, Matrix& V, Real truncerr, int maxm)
    {
    int m = A.Nrows(), n = A.Ncols();	// want m >= n
    if(m < n)
	{
	Matrix Ut, Vt;
	svdcut(A.t(),Ut,d,Vt,truncerr,maxm);
	U = Vt.t();
	V = Ut.t();
	return;
	}
    if(1)
	{
	Matrix aa = A,uu,vv;
	//thinsvd(aa,uu,d,vv,truncerr * 0.01);
//	thinsvd(aa,uu,d,vv,1.0e-26);
	//cout << "err crit = " << truncerr * 0.01 << " ";
	//checkSVD(aa,uu,d,vv);
	int k = d.Length();
	Real err = 0.0;
	while(k > maxm || (err+d(k)*d(k) < truncerr*d(1)*d(1) && k > 1))
	    err += d(k)*d(k), k--;
	svdtruncerr = err/d(1)/d(1);
	if(d(1) == 0.0) svdtruncerr = 0.0;
	U = uu.Columns(1,k);
	V = vv.Rows(1,k);
	d.ReduceDimension(k);
	return;
	}
    Matrix AA(A), evecs;
    Vector evals;
    Matrix Asq = AA.t() * AA;
    Real sca = 0.0;
    for(int i = 1; i <= n; i++)
	for(int j = 1; j <= n; j++)
	    if(fabs(Asq(i,j)) > sca) sca = fabs(Asq(i,j));
    if(sca > 0.0) Asq *= -1.0/sca;
    EigenValues(Asq,evals,evecs);
    evals *= -sca;
    int k = n;
    Real err = 0.0;
    while(k > maxm || (err+evals(k) < truncerr*evals(1) && k > 1))
	err += evals(k--);
    svdtruncerr = err/evals(1);
    if(evals(1) == 0.0) svdtruncerr = 0.0;
    if(ran1() < 0.002) cout << "svdcut keeps " << k SP svdtruncerr << endl;
    V = evecs.Columns(1,k).t();
    U = AA * V.t();
    d.ReDimension(k);
    for(int i = 1; i <= k; i++)
	d(i) = sqrt(evals(i)),
	U.Column(i) *= 1.0 / d(i);
    }

void MPO_to_MPS(const MPO& M, MPS& m)
    {
    m.N = M.N;
    m.posi = M.posi;
    m.maxm = M.maxm;
    m.cutoff = M.cutoff;
    m.A = M.A;
    for(int i = 1; i <= m.N; i++)
	m.A[i] = m.A[i] * M.Iss->comb[i];
    m.Iss = M.Iss->pst;
    }
void MPS_to_MPO(const MPS& M, MPO& m)
    {
    m.N = M.N;
    m.posi = M.posi;
    m.maxm = M.maxm;
    m.cutoff = M.cutoff;
    m.A = M.A;
    m.Iss = M.Iss->pfrom;
    for(int i = 1; i <= m.N; i++)
	m.A[i] = m.A[i] * m.Iss->comb[i];
    }

void SVDeither(ITensor AB, ITensor& A, ITensor& B,Real cutoff, int maxm, bool putlamright)
    {
    if(AB.findindex(IndReIm) > 0)
	{
	do_denmat_complex(AB,A,B,cutoff,maxm,putlamright,false);
	return;
	}
    do_denmat_Real(AB,A,B,cutoff,maxm,putlamright,false);
    }

void plussers(Index l1, Index l2, Index& sumind, ITensor& first, ITensor& second)
    {
    sumind.setm(l1.m()+l2.m());
    first = ITensor(l1,sumind);
    second = ITensor(l2,sumind);
    for(int i = 1; i <= l1.m(); i++)
	first(i,i) = 1.0;
    for(int i = 1; i <= l2.m(); i++)
	second(i,l1.m()+i) = 1.0;
    }

// res = sum_l=1^n  coefs(l) xi(l)
void nfitset(vector<MPS>& xxi, Vector& coefs, MPS& res,Real cut, int maxm)
{
    int n = coefs.Length();
    //cout << "starting nfitset, n = " << n << endl;
    int N = xxi[1].N;
    vector<MPS> xi(xxi);
    for(int j = 1; j <= n; j++)
	{
	xi[j].position(N-1); 
	xi[j].position(1);
	xi[j].A[2] *= coefs(j);
	}
    res = xi[1];
    res.newindices();
    res.cutoff = cut;
    res.maxm = maxm;
    if(n == 1) return;
    if(n == 2)
	{
        vector<ITensor> first(N), second(N);
        for(int i = 1; i < N; i++)
            {
            Index l1 = xi[1].LinkInd(i);
            Index l2 = xi[2].LinkInd(i);
            Index r(Link);
            plussers(l1,l2,r,first[i],second[i]);
            }
        res.A[1] = xi[1].A[1] * first[1] + xi[2].A[1] * second[1];
        res.A[N] = xi[1].A[N] * first[N-1] + xi[2].A[N] * second[N-1];
        for(int i = 2; i < N; i++)
            res.A[i] = first[i-1] * xi[1].A[i] * first[i] + second[i-1] * xi[2].A[i] * second[i];
        /*
        cout << "initial nfitset dimensions of As are:\n";
        for(int i = 1; i < N; i++)
            cout << res.LinkInd(i).m() << " ";
        cout << endl;
        */
        res.cutoff = cut;
        res.position(N-1);
        res.position(1);
        /*
        cout << "Final/after position(1) dimensions of As are:\n";
        for(int i = 1; i < N; i++)
            cout << res.LinkInd(i).m() << " ";
        cout << endl;
        */
        return;
	}
    if(n > 2)
	{
        Vector ncoefs(2);
        vector<MPS> xi2(3);
        vector<MPS> nxi;
        MPS junk;
        nxi.push_back(junk);
        for(int i = 1; i <= n-1; i += 2)
            {
            xi2[1] = xxi[i];
            xi2[2] = xxi[i+1];
            ncoefs(1) = coefs(i);
            ncoefs(2) = coefs(i+1);
            nfitset(xi2, ncoefs, res,cut, maxm);
            nxi.push_back(res);
            }
        if(n%2 == 1)
            {
            nxi.push_back(xxi[n]);
            nxi[nxi.size()-1].A[2] *= coefs(n);
            }
        ncoefs.ReDimension(nxi.size() - 1);
        ncoefs = 1.0;
        nfitset(nxi, ncoefs, res,cut, maxm);
        return;
	}
}

void nfitset(vector<MPO>& xxi, Vector& coefs, MPO& res, Real cut, int maxm)
{
    vector<MPS> yy(xxi.size());
    res = xxi[1];
    MPS yres;
    for(unsigned int i = 1; i < xxi.size(); i++)
	MPO_to_MPS(xxi[i], yy[i]);
    nfitset(yy, coefs, yres,cut,maxm);
    MPS_to_MPO(yres,res);
}

void nmultMPO(MPO& Aorig, MPO& Borig, MPO& res,Real cut, int maxm)
{
    if(Aorig.N != Borig.N)
	error("bad N in multMPO");
    int N = Borig.N;
    MPO B(Borig);
    B.newindices();
    for(int i = 1; i <= N; i++)
	{
	B.A[i].mapindex(B.ti(i),B.ti(i).primed());
	B.A[i].mapindex(B.si(i),B.ti(i));
	}
    MPO A(Aorig);
    A.newindices();
    A.position(1);
    B.position(1);
    res = A;
    res.newindices();
    for(int i = 1; i <= N; i++)
	res.A[i].mapindex(res.ti(i),res.ti(i).primed());
    ITensor clust,nfork;
    vector<int> midsize(N);
    for(int i = 1; i < N; i++)
	{
	if(i == 1)
	    clust = A.A[i] * B.A[i];
	else
	    clust = nfork * A.A[i] * B.A[i];
	if(i == N-1) break;
	Index oldmid = res.LinkInd(i);
	nfork = ITensor(A.LinkInd(i),B.LinkInd(i),oldmid);
	SVDeither(clust, res.A[i], nfork,cut, maxm, true);
	Index mid = index_in_common(res.A[i],nfork,Link);
	midsize[i] = mid.m();
	res.A[i+1] = ITensor(mid,res.si(i+1),res.ti(i+1).primed(),res.LinkInd(i+1));
	}
    nfork = clust * A.A[N] * B.A[N];
    res.posi = N-1;
    res.doSVD(N-1,nfork,fromright,false);
    res.position(1);
    for(int i = 1; i <= N; i++)
	res.A[i].noprime();
    /*
    cout << "nmultMPO res sizes" << endl;
    for(int i = 1; i < N-1; i++)
	cout << i SP midsize[i] SP res.LinkInd(i).m() << endl;
    */
}

void do_denmat_complex(const ITensor& nA, ITensor& A, ITensor& B,
	Real cutoff,int maxm, bool lamright, bool donormalize)
    {
    Index l(Link,"left combined"), r(Link,"right combined");
    Combiner comb_l(l), comb_r(r);
    Index mid = index_in_common(A,B,Link);
    getprodcombiners(A, B, comb_l,l, comb_r,r);
    ITensor nnA = nA * comb_l * comb_r;
    Index active = lamright ? l : r;
    Index activep = active.primed();
    int n = active.m();

    if(donormalize)
	nnA.logfac -= nnA.lognorm();

    ITensor nnAconj = conj(nnA);
    nnAconj.mapindex(active,activep);
    ITensor rhore, rhoim, rho = nnA * nnAconj;
    rho.SplitReIm(rhore,rhoim);
    
    Matrix Mre(n,n), Mim(n,n), Ure, Uim;
    Vector d;
    rhore.getMatrix11(active,activep,Mre);
    rhoim.getMatrix11(active,activep,Mim);
    ComplexEigenvalues(Mre, Mim, d, Ure, Uim);

    if(specialdebug1) cout << "complex eigs are\n" << d;
    Real err = 0.0;
    int mp = d.Length();
    while(mp > maxm || (err+d(mp) < cutoff*d(1) && mp > 1))
	err += d(mp--);
    Real svdtruncerr = (d(1) == 0 ? 0.0 : err/d(1));
    if(specialdebug1) cout << "mp, n are \n" << mp SP n << endl;
    if(specialdebug1 && mp < n) cout << "d(mp+1) is " << d(mp+1) << endl;
    //if(mp > 5 && ran1() < 0.001) cout << "do_denmat_complex keeps " << mp SP svdtruncerr << endl;
    d.ReduceDimension(mp);
    lastd = d;
    int mpshow = min(20,min(d.Length(),mp+3));
    if(0)for(int j = 1; j <= mpshow; j++)
	cout << j SP setprecision(12) << d(j) << endl;

    Matrix UUre = Ure.Columns(1,mp), UUim = Uim.Columns(1,mp);
    mid.setm(mp);
    ITensor nUre(active,mid), nUim(active,mid);
    nUre.fromMatrix11(active,mid,UUre);
    nUim.fromMatrix11(active,mid,UUim);
    ITensor nU = nUre * Complex_1 + nUim * Complex_i;
    ITensor other = conj(nU) * nnA;
    if(lamright)
	A = nU * comb_l, B = other * comb_r;
    else
	B = nU * comb_r, A = other * comb_l;
    }

void do_denmat_Real(const ITensor& nA, ITensor& A, ITensor& B,
	Real cutoff,int maxm, bool lamright, bool donormalize)
    {
    Index l(Link,"left combined"), r(Link,"right combined");
    Combiner comb_l(l), comb_r(r);
    Index mid = index_in_common(A,B,Link);
    getprodcombiners(A, B, comb_l,l, comb_r,r);
    ITensor nnA = nA * comb_l * comb_r;
    Index active = lamright ? l : r;
    Index activep = active.primed();
    int n = active.m();
    /*
    static int maxn = 10;
    if(n > maxn)
	{
	maxn = n;
	cout << "New biggest denmat: " << maxn  << " (" << l.m() << "," << r.m() << ")" << endl;
	}
    */

    ITensor nnAconj = nnA;
    nnAconj.mapindex(active,activep);
    ITensor rho = nnA * nnAconj;
    
    Matrix M(n,n), U;
    Vector d;
    rho.getMatrix11(active,activep,M);
    M *= -1.0;
    EigenValues(M,d,U);
    d *= -1.0;
    Real err = 0.0;
    int mp = d.Length();
    while(mp > maxm || (err+d(mp) < cutoff*d(1) && mp > 1))
	err += sqr(d(mp--));
    Real svdtruncerr = (d(1) == 0 ? 0.0 : err/d(1));
    //if(mp > 5 && ran1() < 0.001) cout << "do_denmat_Real keeps " << mp SP svdtruncerr SP cutoff << endl;
    d.ReduceDimension(mp);
    lastd = d;
    int mpshow = min(20,min(d.Length(),mp+3));
    if(0)for(int j = 1; j <= mpshow; j++)
	cout << j SP setprecision(12) << d(j) << endl;

    Matrix UU = U.Columns(1,mp);
    mid.setm(mp);
    ITensor nU(active,mid);
    nU.fromMatrix11(active,mid,UU);
    ITensor other = nU * nnA;
    if(donormalize) { }
    if(lamright)
	A = nU * comb_l, B = other * comb_r;
    else
	B = nU * comb_r, A = other * comb_l;
    }

void napplyMPO(MPS& x, MPO& K, MPS& res)  // apply using fitting; 
{
    if(x.N != K.N)
	error("bad N in multMPO");
    int N = x.N;
    if(x.posi != 1 && x.posi != 2)
	error("bad posi for x");
    if(K.posi != 1 && K.posi != 2)
	error("bad posi for K");
    res = x;
    res.newindices();
    for(int i = 1; i <= N; i++)
	res.A[i].mapindex(x.si(i),x.ti(i));
    ITensor clust,nfork;
    vector<int> midsize(N);
    int midmax = 1;
    for(int i = 1; i < N; i++)
	{
	if(i == 1)
	    clust = x.A[i] * K.A[i];
	else
	    clust = nfork * x.A[i] * K.A[i];
	if(i == N-1) break;
	Index oldmid = res.LinkInd(i);
	nfork = ITensor(x.LinkInd(i),K.LinkInd(i),oldmid);
	SVDeither(clust, res.A[i], nfork,x.cutoff, x.maxm, true);
	Index mid = index_in_common(res.A[i],nfork,Link);
	midsize[i] = mid.m();
	if(midsize[i] > midmax) midmax = midsize[i];
	res.A[i+1] = ITensor(mid,res.ti(i+1),res.LinkInd(i+1));
	}
    nfork = clust * x.A[N] * K.A[N];
    res.posi = N-1;
    res.doSVD(N-1,nfork,fromright,false);
    res.position(1);
    for(int i = 1; i <= N; i++)
	res.A[i].mapindex(x.ti(i),x.si(i));
    //cout << "napplyMPO res sizes" << endl;
    int maxm = 1;
    for(int i = 1; i < N-1; i++)
	{
	int mm = res.LinkInd(i).m();
	if(mm > maxm) maxm = mm;
	}
    //cout << "napplyMPO: midmax, maxm = " << midmax SP maxm << endl;
    if(0)for(int i = 1; i < N-1; i++)
	cout << i SP midsize[i] SP res.LinkInd(i).m() << endl;
}

long factorial(int i)
    {
    long res = 1;
    for(int j = 2; j <= i; j++)
	res *= j;
    return res;
    }
void expsmallH(const MPO& H, MPO& K, Real tau, Real Etot,Real Kcutoff, bool realtime)
    {
    int N = H.N;
    Real estnorm = 2 * N * tau;	// Assume max eig of H is about N, extra factor of 2 for safety
    HamBuilder hb(*H.Iss);
    MPO constterm(*H.Iss,400,Kcutoff,1), Hshift(*H.Iss,400,Kcutoff,1);
    hb.getidentity(constterm,-Etot);
    vector<MPO> xx;
    xx.push_back(constterm);	// first doesn't count
    xx.push_back(constterm);
    xx.push_back(H);
    Vector coef(2);
    coef = 1.0;
    hb.getidentity(Hshift,0.0);
    //fitmposet(xx,coef,Hshift,Kcutoff,400);
    nfitset(xx,coef,Hshift,Kcutoff,400);
    Hshift.A[2] *= -tau;
    hb.getidentity(constterm,1.0);
    xx[1] = constterm;
    MPO term(Hshift);

    for(int o = 50; o >= 1; o--)
	{
	cout << "o = " << o << endl;
	if(o > 1) term.A[2].dat *= 1.0 / o;
	xx[2] = term;
	//fitmposet(xx,coef,K,Kcutoff,400);
	Real errlim = Kcutoff / sqr(pow(estnorm,o) / factorial(o));
	cout << "errlim in expsmallH is " << errlim << endl;
	if(errlim > 1.0e-6) 
	    { cout << "resetting to 10^-6" << endl; errlim = 1.0e-6; }
	if(errlim < 1.0e-14) 
	    { cout << "resetting to 10^-14" << endl; errlim = 1.0e-14; }
	
	errlim = 1.0e-14;

	nfitset(xx,coef,K,errlim,400);	// heuristic
	if(o > 1)
	    nmultMPO(K,Hshift,term,errlim,400);
	}
    }

void expH(const MPO& H, MPO& K, Real tau, Real Etot,Real Kcutoff, int ndoub,bool realtime)
    {
    int N = H.N;
    Real ttau = tau / pow(2.0,ndoub);
    cout << "ttau in expH is " << ttau << endl;
    K.cutoff = 0.1 * Kcutoff * pow(0.25,ndoub);
    expsmallH(H, K, ttau,Etot,K.cutoff,false);

    //cout << "Starting doubling in expH" << endl;
    for(int doub = 1; doub <= ndoub; doub++)
	{
	//cout << " Double step " << doub << endl;
	K.cutoff = 0.1 * Kcutoff * pow(0.25,ndoub-doub);
	if(doub == ndoub) K.cutoff = Kcutoff;
	//cout << "in expH, K.cutoff is " << K.cutoff << endl;
	MPO KK(K);
	KK.newindices();
	nmultMPO(K,K,KK,K.cutoff,K.maxm);
	K = KK;
	if(doub == ndoub)
	    {
	    cout << "step " << doub << ", K is " << endl;
	    cout << "K.cutoff, K.maxm are " << K.cutoff SP K.maxm << endl;
	    for(int i = 1; i <= N; i++)
		cout << i SP K.A[i];
	    }
	}
    }

void measure_state(const MPS& phi,vector<Real>& sx,vector<Real>& sy,vector<Real>& sz)
{
    MPS psi = phi;
    int N = psi.NN();

    sx = vector<Real>(N+1);
    sy = vector<Real>(N+1);
    sz = vector<Real>(N+1);

    for(int i = 1; i <= N; i++)
	{
        ITensor tsx(makesx(psi.si(i)));
        ITensor tsy(makesy(psi.si(i)));
        ITensor tsz(makesz(psi.si(i)));
        int l = (i == 1 ? 1 : i-1);
        psi.position(l);
        ITensor AA = psi.A[l] * psi.A[l+1];

        Real norm = RDot(AA,AA);
        if(norm == 0.0) error("bad norm in measure_state");

        ITensor aa = AA * tsz;
        aa.noprime();
        sz[i] = RDot(AA,aa) / norm; 

        aa = AA * tsx;
        aa.noprime();
        sx[i] = RDot(AA,aa) / norm; 

        aa = AA * tsy;
        aa.noprime();
        sy[i] = RDot(AA,aa) / norm; 
	}
}

Real dmrg(MPS& psi, const MPO& finalham, const Sweeps& sweeps)
{

    Real energy;

    int N = psi.NN();

    psi.position(1);

    vector<ITensor> leftright(N);

    MPS psiconj(psi);
    for(int i = 1; i <= finalham.N; i++)
	{
        psiconj.A[i] = conj(psi.A[i].primelink());
        psiconj.A[i].mapindex(finalham.si(i),finalham.ti(i));
	}

    leftright[N-1] = psi.AA(N) * finalham.AA(N) * psiconj.AA(N);

    for(int l = N-2; l >= 2; l--)
        leftright[l] = leftright[l+1] * psi.AA(l+1) * finalham.AA(l+1) * 
                psiconj.AA(l+1);

    for(int sw = 1; sw <= sweeps.nsweep(); sw++)
	for(int l = 1, ha = 1; ha != 3; sweepnext(l,ha,N))
    {
	    cout << "starting sweep step " << sw SP ha SP l << endl;

	    ITensor mpoh = finalham.AA(l) * finalham.AA(l+1);
	    mpoh.mapindex(finalham.ti(l),finalham.si(l).primed());
	    mpoh.mapindex(finalham.ti(l+1),finalham.si(l+1).primed());

	    ITensor phi = psi.AA(l) * psi.AA(l+1), phip;

	    int dim = phi.dat.Length();
	    Matrix evecs(sweeps.niter(sw),dim);
	    Vector evals;
	    phi.AssignToVec(evecs.Row(1));
	    evecs.Row(1) *= 1.0 / Norm(evecs.Row(1));

	    if(l == 1)
		{
            ILocalHam lham(leftright[2],mpoh,phi);
            David(lham,1,1e-4,evals,evecs,1,1,1);
		}
	    else if(l == N-1)
		{
            ILocalHam lham(leftright[l],mpoh,phi);
            David(lham,1,1e-4,evals,evecs,1,1,1);
		}
	    else 
		{
            ILocalHam lham(leftright[l],leftright[l+1],mpoh,phi);
            David(lham,1,1e-4,evals,evecs,1,1,1);
		}
	    energy = evals(1);
	    phi.AssignFromVec(evecs.Row(1));
	    do_denmat_Real(phi,psi.AA(l),psi.AA(l+1),sweeps.cutoff(sw),sweeps.maxm(sw),ha==1,false);

	    psiconj.A[l] = conj(psi.A[l].primelink());
	    psiconj.A[l].mapindex(finalham.si(l),finalham.ti(l));
	    psiconj.A[l+1] = conj(psi.A[l+1].primelink());
	    psiconj.A[l+1].mapindex(finalham.si(l+1),finalham.ti(l+1));

	    Index ll = psi.LinkInd(l);
	    cout << "kept: " << setprecision(12) << sweeps.cutoff(sw) 
			SP sweeps.maxm(sw) SP ll.m() << endl;
	    if(ha == 1)
		{
            if(l == 1)
                leftright[2] = psi.AA(1) * finalham.AA(1) * psiconj.AA(1);
            else if(l != N-1)
                leftright[l+1] = leftright[l] * psi.AA(l) * finalham.AA(l) * psiconj.AA(l);
		}
	    else
		{
            if(l == N-1)
                leftright[l] = psi.AA(N) * finalham.AA(N) * psiconj.AA(N);
            else if(l != 1)
                leftright[l] = leftright[l+1] * psi.AA(l+1) * finalham.AA(l+1) * 
                    psiconj.AA(l+1);
		}
    }
    return energy;
}

//Given the name of a model/operator and two indices, returns an ITensor W
//encoding a translation invariant MPO with the following index structure:
/*
*          S
*          |
*      L ~{W}~ L'
*          | 
*          S'
*/ 
ITensor makeiMPO(string name, int d, Index& L, Index& S, vector<Real> couplings)
{
    ITensor W;
    S.setm(d);

    if(name == "ising")
    {
        //Transverse field Ising model
        //H = \sum_i J \sigma^z_i \sigma^z_{i+1} - lambda \sigma^x
        //For S=1/2, cts. phase transition at lambda/J == 1

        if(couplings.size() <= 2) error("Two couplings J and lambda required for model 'ising'.");
        Real J = couplings[1];
        Real lambda = couplings[2];

        L.setm(3);
        W = ITensor(S,S.primed(),L,L.primed());

        if(d == 2)
        {
            W(1,1,1,1) = 1.0;     W(2,2,1,1) = 1.0;      //Ident in ul corner
            W(1,1,3,3) = 1.0;     W(2,2,3,3) = 1.0;      //Ident in lr corner
            W(1,1,2,1) = J;       W(2,2,2,1) = -J;       //J*Sz in middle left
            W(1,1,3,2) = 1.0;     W(2,2,3,2) = -1.0;     //Sz in bottom middle
            W(1,2,3,1) = -lambda; W(2,1,3,1) = -lambda;  //-lamdba*Sx in lower left
        }
        else error("Model not defined for this d.");
    }
    else if(name == "heisenberg")
    {
        //Heisenberg model

        if(couplings.size() <= 1) error("At least one coupling J required for model 'heisenberg'.");

        Real Jxy = 0, Jz = 0;
        if(couplings.size() == 2)
        {
            Jz = Jxy = couplings[1];
        }
        else if(couplings.size() >= 3)
        {
            Jz = couplings[1];
            Jxy = couplings[2];
        }

        L.setm(5);
        W = ITensor(S,S.primed(),L,L.primed());

        if(d == 2)
        {
            W(1,1,1,1) = 1.0;    W(2,2,1,1) = 1.0;       //Ident in ul corner
            W(1,1,2,1) = Jz*0.5;  W(2,2,2,1) = -Jz*0.5;  //Jz*Sz
            W(2,1,3,1) = Jxy*0.5;                        //Jxy/2*S-
            W(1,2,4,1) = Jxy*0.5;                        //Jxy/2*S+
            W(1,1,5,2) = 0.5;    W(2,2,5,2) = -0.5;      //Sz
            W(1,2,5,3) = 1.0;                            //S+
            W(2,1,5,4) = 1.0;                            //S-
            W(1,1,5,5) = 1.0;    W(2,2,5,5) = 1.0;       //Ident in lr corner

        }
        else if(d == 3)
        {
            W(1,1,1,1) = 1.0;     W(2,2,1,1) = 1.0;     W(3,3,1,1) = 1.0;      //Ident in ul corner
            W(1,1,5,5) = 1.0;     W(2,2,5,5) = 1.0;     W(3,3,5,5) = 1.0;      //Ident in lr corner
            W(1,1,2,1) = Jz;      W(2,2,2,1) = 0.0;     W(3,3,2,1) = -Jz;      //Jz*Sz
            W(2,1,3,1) = Jxy;     W(3,2,3,1) = Jxy;                            //Jxy*S-/Sqrt(2)
            W(1,2,4,1) = Jxy;     W(2,3,4,1) = Jxy;                            //Jxy*S+/Sqrt(2)
            W(1,1,5,2) = 1.0;     W(2,2,5,2) = 0.0;     W(3,3,5,2) = -1.0;     //Sz
            W(1,2,5,3) = 1.0;     W(2,3,5,3) = 1.0;                            //S+/Sqrt(2)
            W(2,1,5,4) = 1.0;     W(3,2,5,4) = 1.0;                            //S-/Sqrt(2)
        }
        else error("Model not defined for this d.");
    }
    else if(name == "bilinear-biquadratic")
    {
        //H = \sum_i J S_i.S_{i+1} - K (S_i.S_{i+1})^2

        if(couplings.size() <= 2) error("Two couplings J and K required for model 'bilinear-biquadratic'.");
        Real J = couplings[1];
        Real K = couplings[2];

        L.setm(11);
        W = ITensor(S,S.primed(),L,L.primed());

        if(d == 3)
        {
            W(1,1,1,1) = 1.0;     W(2,2,1,1) = 1.0;     W(3,3,1,1) = 1.0;      //Ident in ul corner
            W(1,1,2,1) = 1.0;     W(2,2,2,1) = 0.0;     W(3,3,2,1) = -1.0;     //Sz
            W(2,1,3,1) = Sqrt2;   W(3,2,3,1) = Sqrt2;                          //S-
            W(1,2,4,1) = Sqrt2;   W(2,3,4,1) = Sqrt2;                          //S+
            W(1,1,5,1) = 1.0;     W(2,2,5,1) = 0.0;     W(3,3,5,1) = 1.0;      //Sz^2
            W(1,2,6,1) = Sqrt2;                                                //Sz S+
            W(3,2,7,1) = -Sqrt2;                                               //Sz S-
            W(1,3,8,1) = 2;                                                    //S+^2
            W(2,2,9,1) = 2;       W(3,3,9,1) = 2;                              //S- S+
            W(3,1,10,1) = 2;                                                   //S-^2
            W(1,1,11,2) = J;      W(2,2,11,2) = -K;     W(3,3,11,2) = -J-K;    //(J+K) Sz - K/2 S+ S-
            W(1,2,11,3) = J/Sqrt2; W(2,3,11,3) = (J+K)/Sqrt2;                  //(J+K)/2 S+ - K/2 Sz S+
            W(2,1,11,4) = (J+K)/Sqrt2; W(3,2,11,4) = J/Sqrt2;                  //(J+K)/2 S- + K/2 Sz S-
            W(1,1,11,5) = -K;     W(3,3,11,5) = -K;                            //-K Sz^2
            W(2,1,11,6) = -K/Sqrt2; W(3,2,11,6) = K/Sqrt2;                     //-K Sz S- - K/2 S-
            W(1,2,11,7) = -K/Sqrt2; W(2,3,11,7) = K/Sqrt2;                     //-K Sz S+ + K/2 S+
            W(3,1,11,8) = -K/2;                                                 //-K/4 S-^2
            W(1,1,11,9) = -K/2;   W(2,2,11,9) = -K;    W(3,3,11,9) = -K/2;     //-K/2 S+ S- + K/2 Sz
            W(1,3,11,10) = -K/2;                                               //-K/4 S+^2
            W(1,1,11,11) = 1.0;   W(2,2,11,11) = 1.0;   W(3,3,11,11) = 1.0;    //Ident in lr corner
        }
        else error("Model not defined for this d.");
    }
    else if(name == "ferroquadrupolar structure factor")
    {
        //H = \sum_{i < j} ( 1/2 S_i.S_{i+1} + (S_i.S_{i+1})^2 )
        //  = \sum_{i < j} ( Tr[Q_i Q_j] + 4/3 )

        //When using this as an MPO, say "QQ", the quantity to measure
        //is QSF(k=0) = -4/3 + 2/(N*(N-1)) * <QQ>
        //Gives k=0 value of Quadrupolar Structure Factor

        L.setm(11);
        W = ITensor(S,S.primed(),L,L.primed());

        if(d == 2)
        {
            error("Spin 1/2 end states for QSF measurements not currently supported.");
            W(1,1,1,1) = 1.0;     W(2,2,1,1) = 1.0;         //Ident in ul corner
            W(1,1,2,1) = 0.25;    W(2,2,2,1) = 0.25;        //Sz*Sz
            W(1,1,2,2) = 1.0;     W(2,2,2,2) = 1.0;         //Ident at 2,2
            W(1,2,3,1) = -0.25;   W(2,1,3,1) = 0.25;        //Sx*Sz
            W(1,1,3,3) = 1.0;     W(2,2,3,3) = 1.0;         //Ident at 3,3
            W(1,2,4,1) = 0.25;    W(2,1,4,1) = -0.25;       //Sz*Sx
            W(1,1,4,4) = 1.0;     W(2,2,4,4) = 1.0;         //Ident at 4,4
            W(1,1,5,1) = 15.0/64.0; W(2,2,5,1) = 15.0/64.0; //15.0/64.0 * Ident (constant shift)
            W(1,1,5,2) = 0.75;    W(2,2,5,2) = 0.75;        //3*Sz*Sz
            W(1,2,5,3) = -0.75;   W(2,1,5,3) = 0.75;        //3*Sx*Sz
            W(1,2,5,4) = -0.75;   W(2,1,5,4) = 0.75;        //3*Sx*Sz
            W(1,1,5,5) = 1.0;     W(2,2,5,5) = 1.0;         //Ident in lr corner
        }
        else if(d == 3)
        {
            // H = \sum_{i<j} ( 1/2 S_i.S_j + (S_i.S_j)^2 )  
            W(1,1,1,1) = 1.0;     W(2,2,1,1) = 1.0;     W(3,3,1,1) = 1.0;        //Ident in ul corner
            W(1,1,2,2) = 1.0;     W(2,2,2,2) = 1.0;     W(3,3,2,2) = 1.0;        //Ident at 2,2
            W(1,1,3,3) = 1.0;     W(2,2,3,3) = 1.0;     W(3,3,3,3) = 1.0;        //Ident at 3,3
            W(1,1,4,4) = 1.0;     W(2,2,4,4) = 1.0;     W(3,3,4,4) = 1.0;        //Ident at 4,4
            W(1,1,5,5) = 1.0;     W(2,2,5,5) = 1.0;     W(3,3,5,5) = 1.0;        //Ident at 5,5
            W(1,1,6,6) = 1.0;     W(2,2,6,6) = 1.0;     W(3,3,6,6) = 1.0;        //Ident at 6,6
            W(1,1,7,7) = 1.0;     W(2,2,7,7) = 1.0;     W(3,3,7,7) = 1.0;        //Ident at 7,7
            W(1,1,8,8) = 1.0;     W(2,2,8,8) = 1.0;     W(3,3,8,8) = 1.0;        //Ident at 8,8
            W(1,1,9,9) = 1.0;     W(2,2,9,9) = 1.0;     W(3,3,9,9) = 1.0;        //Ident at 9,9
            W(1,1,10,10) = 1.0;   W(2,2,10,10) = 1.0;   W(3,3,10,10) = 1.0;      //Ident at 10,10
            W(1,1,11,11) = 1.0;   W(2,2,11,11) = 1.0;   W(3,3,11,11) = 1.0;      //Ident in lr corner

            W(1,1,2,1) = 1.0;     W(2,2,2,1) = 0.0;     W(3,3,2,1) = -1.0;     //Sz
            W(2,1,3,1) = Sqrt2;   W(3,2,3,1) = Sqrt2;                          //S-
            W(1,2,4,1) = Sqrt2;   W(2,3,4,1) = Sqrt2;                          //S+
            W(1,1,5,1) = 1.0;     W(2,2,5,1) = 0.0;     W(3,3,5,1) = 1.0;      //Sz^2
            W(1,2,6,1) = Sqrt2;                                                //Sz S+
            W(3,2,7,1) = -Sqrt2;                                               //Sz S-
            W(1,3,8,1) = 2;                                                    //S+^2
            W(2,2,9,1) = 2;       W(3,3,9,1) = 2;                              //S- S+
            W(3,1,10,1) = 2;                                                   //S-^2
            //W(1,1,11,1) = 5.0/6.0; W(2,2,11,1) = 5.0/6.0; W(3,3,11,1) = 5.0/6.0;    //5.0/6.0 * Ident (constant shift)
            W(1,1,11,2) = 0.5;      W(2,2,11,2) = 1.0;     W(3,3,11,2) = 0.5;    //-1/2 Sz + 1/2 S+ S-
            W(1,2,11,3) = 0.5/Sqrt2; W(2,3,11,3) = -0.5/Sqrt2;                  //-1/4 S+ + 1/2 Sz S+
            W(2,1,11,4) = -0.5/Sqrt2; W(3,2,11,4) = 0.5/Sqrt2;                  //-1/4 S- - 1/2 Sz S-
            W(1,1,11,5) = 1.0;     W(3,3,11,5) = 1.0;                            //Sz^2
            W(2,1,11,6) = 1.0/Sqrt2; W(3,2,11,6) = -1.0/Sqrt2;                     // Sz S- + 1/2 S-
            W(1,2,11,7) = 1.0/Sqrt2; W(2,3,11,7) = -1.0/Sqrt2;                     // Sz S+ - 1/2 S+
            W(3,1,11,8) = 1.0/2;                                                 //1/4 S-^2
            W(1,1,11,9) = 1.0/2;   W(2,2,11,9) = 1.0;    W(3,3,11,9) = 1.0/2;     //1/2 S+ S- - 1/2 Sz
            W(1,3,11,10) = 1.0/2;                                               //1/4 S+^2
        }
        else error("Model not defined for this d.");
    }
    else if(name == "magnetization")
    {
        if(couplings.size() <= 3) error("Three component magnetization axis vector required for magnetization MPO.");
        Real vx = couplings[1];
        Real vy = couplings[2];
        Real vz = couplings[3];

        L.setm(2);
        ITensor WR(S,S.primed(),L,L.primed());
        ITensor WI(S,S.primed(),L,L.primed());

        if(d == 2)
        {

            WR(1,1,1,1) = 1.0;     WR(2,2,1,1) = 1.0;      //Ident in ul corner
            WR(1,1,2,1) = vz/2.0;  WR(1,2,2,1) = vx/2.0; WR(2,1,2,1) = vx/2.0; WR(2,2,2,1) = -vz/2.0;
            WR(1,1,2,2) = 1.0;     WR(2,2,2,2) = 1.0;      //Ident in lr corner

            WI(1,2,2,1) = -vy/2.0; WI(2,1,2,1) = vy/2.0;
            
            if(fabs(vy) > 1.0E-15)
            {
                W = WR * Complex_1 + WI * Complex_i;
            }
            else
            {
                W = WR;
            }
        }
        else if(d == 3)
        {
            WR(1,1,1,1) = 1.0;     WR(2,2,1,1) = 1.0;     WR(3,3,1,1) = 1.0;        //Ident in ul corner
            WR(1,1,2,1) = vz;      WR(3,3,2,1) = -vz;
            WR(1,2,2,1) = vx/Sqrt2; WR(2,1,2,1) = vx/Sqrt2; WR(2,3,2,1) = vx/Sqrt2; WR(3,2,2,1) = vx/Sqrt2; 
            WR(1,1,2,2) = 1.0;     WR(2,2,2,2) = 1.0;     WR(3,3,2,2) = 1.0;        //Ident in lr corner

            WI(1,2,2,1) = -vy/Sqrt2; WI(2,1,2,1) = vy/Sqrt2; WI(2,3,2,1) = -vy/Sqrt2; WI(3,2,2,1) = vy/Sqrt2; 
            
            if(fabs(vy) > 1.0E-15)
            {
                W = WR * Complex_1 + WI * Complex_i;
            }
            else
            {
                W = WR;
            }
        }
        else error("Magnetization MPO not defined for this d.");
    }
    else error("Model type not recognized.");

    return W;
} //end makeiMPO

MPO makeMPO(IndexSiteSet& ISS, string name, vector<Real> couplings)
{
    MPO H(ISS);

    int N = H.NN();
    for(int i = 1; i <= N; ++i)
    {
        Index J(Link,"J",1),S(Site,"S",1);
        ITensor K = makeiMPO(name,H.si(i).m(),J,S,couplings); 

        Index L,R;
        if(i > 1) L = H.LinkInd(i-1);
        if(i < N) R = H.LinkInd(i);

        if(i > 1)
        {
            L.setm(J.m());
            K.mapindex(J,L);
        }
        if(i < N)
        {
            R.setm(J.m());
            K.mapindex(J.primed(),R);
        }

        K.mapindex(S,H.si(i)); K.mapindex(S.primed(),H.ti(i));

        //Lower triangular MPO formalism
        if(i == 1)
        {
            ITensor Ledge(J); Ledge.dat = 0.0;
            Ledge(J.m()) = 1.0;
            K = Ledge * K;
        }
        if(i == N)
        {
            ITensor Redge(J.primed()); Redge.dat = 0.0;
            Redge(1) = 1.0;
            K = K * Redge;
        }
        H.A[i] = K;
    }
    return H;
}

